use crate::models::hersteller::Hersteller;
use async_graphql::{Context, FieldResult};
use sqlx::postgres::PgPool;

#[derive(Default)]
pub struct HerstellerMutation;

#[async_graphql::Object]
impl HerstellerMutation {
    async fn create_hersteller(&self, ctx: &Context<'_>, name: String) -> FieldResult<Hersteller> {
        let pool = ctx.data::<PgPool>()?;
        let row = Hersteller::create(pool, &name).await?;
        Ok(row)
    }

    async fn delete_hersteller(&self, ctx: &Context<'_>, id: i32) -> FieldResult<bool> {
        let pool = ctx.data::<PgPool>()?;

        Hersteller::delete(pool, &id).await?;
        Ok(true)
    }

    async fn update_hersteller(
        &self,
        ctx: &Context<'_>,
        id: i32,
        name: String,
    ) -> FieldResult<Hersteller> {
        let pool = ctx.data::<PgPool>()?;

        let row = Hersteller::update(pool, &id, &name).await?;
        Ok(row)
    }
}
