use crate::models::typ::Typ;
use async_graphql::{Context, FieldResult};
use sqlx::postgres::PgPool;

#[derive(Default)]
pub struct TypMutation;

#[async_graphql::Object]
impl TypMutation {
    async fn create_typ(&self, ctx: &Context<'_>, name: String) -> FieldResult<Typ> {
        let pool = ctx.data::<PgPool>()?;
        let row = Typ::create(pool, &name).await?;
        Ok(row)
    }

    async fn delete_typ(&self, ctx: &Context<'_>, id: i32) -> FieldResult<bool> {
        let pool = ctx.data::<PgPool>()?;

        Typ::delete(pool, &id).await?;
        Ok(true)
    }

    async fn update_typ(&self, ctx: &Context<'_>, id: i32, name: String) -> FieldResult<Typ> {
        let pool = ctx.data::<PgPool>()?;

        let row = Typ::update(pool, &id, &name).await?;
        Ok(row)
    }
}
