use async_graphql::{Context, FieldResult, Object};
use sqlx::postgres::PgPool;

use crate::models::typ::Typ;

#[derive(Default)]
pub struct TypQuery {
    pub id: i32,
}

#[Object(extends)]
impl TypQuery {
    // #[graphql(external)]
    // async fn id(&self) -> &i32 {
    //     &self.id
    // }
    // async fn modell<'a>(&self, ctx: &'a Context<'_>) -> FieldResult<Vec<Modell>> {
    //     let pool = ctx.data::<PgPool>().unwrap();
    //     let rows = Modell::read_by_typ(pool, &self.id).await?;
    //     Ok(rows)
    // }

    async fn typen<'a>(&self, ctx: &'a Context<'_>) -> FieldResult<Vec<Typ>> {
        let pool = ctx.data::<PgPool>()?;
        let rows = Typ::read_all(pool).await?;
        Ok(rows)
    }

    async fn typ<'a>(&self, ctx: &'a Context<'_>, id: i32) -> FieldResult<Typ> {
        let pool = ctx.data::<PgPool>()?;
        let row = Typ::read_one(pool, &id).await?;
        Ok(row)
    }

    // #[graphql(entity)]
    // async fn find_typ_by_id<'a>(&self, ctx: &'a Context<'_>, id: i32) -> FieldResult<Typ> {
    //     let pool = ctx.data::<PgPool>().unwrap();
    //     let row = Typ::read_one(pool, &id).await?;
    //     Ok(row)
    // }
}
